package database

import (
	"fmt"
	"net"
	"strings"
	"time"
)

func memcachedCheck(Host string, Port int) (bool, error) {
	client, err := net.DialTimeout("tcp", fmt.Sprintf("%s:%d", Host, Port), 5*time.Second)
	if err != nil {
		return false, err
	}
	err = client.SetDeadline(time.Now().Add(5 * time.Second))
	if err != nil {
		return false, err
	}
	_, err = client.Write([]byte("stats\n"))
	if err != nil {
		return false, err
	}
	rev := make([]byte, 1024)
	n, err := client.Read(rev)
	if err != nil {
		return false, err
	}
	if strings.Contains(string(rev[:n]), "STAT") == false {
		return false, nil
	}
	return true, nil
}
